/* V2Server.java- gets the public key,the hash and the signature 
 *                  from the VClient to verify
 *Vera Arsova, Samuel White 2004
 *********************************************************************/
import java.net.*;
import java.io.*;
import java.io.ByteArrayOutputStream;
import java.lang.*;
import java.util.Random;
import java.security.*;

import java.util.*;
import java.lang.Object;
import java.lang.*;
import java.lang.Byte;
import java.security.spec.*;
import java.math.*;
import java.security.KeyPair;

import javax.crypto.*;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.spec.*;

public class V2ServerB {
     // Verifies the signature for the given buffer of bytes using the public key.
    public static boolean verifySignature(PublicKey key, byte[] buffer, byte[] signature) {
        try {
	    System.out.println("is in");
            Signature sig = Signature.getInstance("RSA");
	    System.out.println("is in 2" + sig);
            sig.initVerify(key);
	     System.out.println("is in 3");
            sig.update(buffer, 0, buffer.length);
	    System.out.println(" the thing inside is " + sig.verify(signature));
            return sig.verify(signature);
        } catch (SignatureException e) {
        } catch (InvalidKeyException e) {
        } catch (NoSuchAlgorithmException e) {
        }
	System.out.println("vero nejke " );
        return false;
    }
 
    public static void main(String[] args) throws IOException{
	DatagramSocket socket = new DatagramSocket(5555);
        ServerSocket serverSocket = null;
        try {
            serverSocket = new ServerSocket(5555);
        } catch (IOException e) {
            System.err.println("Could not listen on port: 5555.");
            System.exit(1);
        }

        Socket clientSocket = null;
        try {
            clientSocket = serverSocket.accept();
        } catch (IOException e) {
            System.err.println("Accept failed.");
            System.exit(1);
        }

        PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
        BufferedReader in = new BufferedReader(
				new InputStreamReader(
				clientSocket.getInputStream()));
        String inputLine, outputLine;
	BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
	inputLine = in.readLine();
	System.out.println("the inputLine(client): "+inputLine);
	 /****************************************
         *
         *geting the public key from the server
         ****************************************/
	byte[] publicKeyBytes = new byte[162];
	try {
	    DatagramPacket packet2 = new DatagramPacket(publicKeyBytes,publicKeyBytes.length);
	    socket.receive(packet2);
	    byte[] reseved = new byte[10];
	    reseved = packet2.getData();
	    publicKeyBytes = packet2.getData();
	    System.out.println("the public key is " + publicKeyBytes);
	}catch (IOException e){
	    System.out.println("nemoze jabi ga" );}

	System.out.println("WAIT for Blind Signature from the server");
	
	/**************************************
         *
         * get the signature from the server
         **************************************/
	byte[] sign = new byte[162];
	try {
	    DatagramPacket packetSign = new DatagramPacket(sign,sign.length);
	    socket.receive(packetSign);
	    byte[] reseved = new byte[162];
	    reseved = packetSign.getData();
	    sign = packetSign.getData();
	    System.out.println("the signature is "+sign);
	}catch (IOException e){
	    System.out.println("nemoze jabi ga" );}
	
	/**********************************************
         *
         * geting the hash from the client
         **********************************************/
	byte[] hash = new byte[20];
	try {
	    DatagramPacket packet = new DatagramPacket(hash,hash.length);
	    socket.receive(packet);
	    byte[] reseved = new byte[10];
	    reseved = packet.getData();
	    hash = packet.getData();
	    System.out.println("the hash is  " + hash);
	}catch (IOException e){
	    System.out.println("nemoze jabi ga" );}

	/****************************************************
         *
         * this is where the byte[] is transformed into keys
         ********************************************************/
	PublicKey publicKey2 = null;
	try{
	    KeyFactory keyFactory = KeyFactory.getInstance("RSA");
	    //System.out.println("********************OVDEKA KEYFACTORY E " +keyFactory);
	    X509EncodedKeySpec publicKeySpec = new X509EncodedKeySpec(publicKeyBytes);
	    publicKey2 = keyFactory.generatePublic(publicKeySpec);
	    System.out.println("the real key is: " + publicKey2);
	}catch (InvalidKeySpecException e){
	    System.out.println("nemozeeeee!!!!!!!!!!!!");
	}catch (NoSuchAlgorithmException e){}

	/*	try {
	    Provider p = new org.bouncycastle.jce.provider.BouncyCastleProvider();
	    Signature sig = Signature.getInstance("SHA-1/RSA",p);
            //Signature sig = Signature.getInstance(publicKey2.getAlgorithm());
	    System.out.println("the sig is " + sig);
            sig.initVerify(publicKey2);
            sig.update(hash, 0, hash.length);
	    System.out.println(" the signature is " + sig.verify(sign));
            //return sig.verify(signature);
        } catch (SignatureException e) {
        } catch (InvalidKeyException e) {
        } catch (NoSuchAlgorithmException e) {
        } */ 

	try {
	// Get a RSA Cipher to decrypt the message
		Cipher cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding");
	cipher.init(Cipher.DECRYPT_MODE, publicKey2);

	byte[] mess_holder = cipher.doFinal(hash); // decrypts signature
	int length = mess_holder.length;

	// Checks for length error
	if (length != hash.length) {
	    System.out.println( "Verification failed, length error");
                      }
	// Check each element for verification
	for (int x = 0; x < length; x++) {
	    if(hash[x] != mess_holder[x]) {
		System.out.println( "Signature failed, element error");
		break; 
	    } 
	}
	} catch (InvalidKeyException e) {
        } catch (NoSuchAlgorithmException e) {
        } catch (IllegalBlockSizeException e) {
	} catch (NoSuchPaddingException e) {
	} catch (BadPaddingException e) {
	}

	/*if (!(verifySignature(publicKey2,hash,sign))){
	    System.out.println("the signature on the hash is verifyed");
	}else{
	    System.out.println("the signature is not valid");
	    }*/
        while ((inputLine = in.readLine()) != null) {
	    System.out.println("the inputLine(client): "+inputLine);
	    outputLine = stdIn.readLine();//"What is your signature?";
	    System.out.println("the outputLine(server): "+outputLine);
	    out.println(outputLine);
	    if (outputLine.equals("Bye."))
                break;
        }
        out.close();
        in.close();
        clientSocket.close();
        serverSocket.close();
    }
}
